#if !defined(AFX_EXTERNDLG_H__E1E64A80_7E50_40E5_9234_BA042C1AB5B5__INCLUDED_)
#define AFX_EXTERNDLG_H__E1E64A80_7E50_40E5_9234_BA042C1AB5B5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ExternDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CExternDlg dialog
#include "MyButton.h"
#include "Si570Driver.h"

class CExternDlg : public CDialog, public CSi570Driver
{
// Construction
public:
	CExternDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CExternDlg();

// Dialog Data
	//{{AFX_DATA(CExternDlg)
	enum { IDD = IDD_EXTIO_DIALOG };
	//}}AFX_DATA


	int			visibility;
	MyButton	b_ATT,b_DX,b_RX,b_manual,b_logo;
	void		Show_GUI(int show);
	void		Switch_GUI();
	void		Set_PRE(int set);
	void		Set_ATT(int set);
	int			isATT() const { return b_ATT.isChecked(); }
	int			isDX() const { return b_DX.isChecked(); }
	void		prepareSaveSettings();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExternDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	// Generated message map functions
	//{{AFX_MSG(CExternDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnAtt();
	afx_msg void OnChnDx();
	afx_msg void OnChnRx();
	virtual void OnManual();
	afx_msg void OnClose();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXTERNDLG_H__E1E64A80_7E50_40E5_9234_BA042C1AB5B5__INCLUDED_)
