////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "RJ10MiniDlg.h"

class CRJ10MiniDlg	*myMainFrm=NULL;

char			myDIR[256];
HCURSOR			m_Hand=NULL,m_FingerDown=NULL,m_FingerRight=NULL,m_UpHand=NULL,m_DownHand=NULL,m_hcurNS=NULL;
CBrush			scopeback,scopelight,scopefill,ana_back,ana_range; //Analyser ColorBrushes
CPen			scopePenLine,scopePenL,scopePenP,scopePenFilter,scopePenMark,scopePenCenter,scopePenSplitLine,scopeLightDotPenCenter;
volatile int	StopFlag=1;
CString			mTitle1,mTitle2,mTitle3;
BOOL			DiRaWaveFlag=FALSE;
HBRUSH			my_backbrush,my_Lbackbrush;
CFont			BigDateFont,BigFont,fontBold,fontRegular,minibigfont,minifont,fixFont;
COLORREF		myDesingTextColor=0,desCol[3]={0};
COLORREF		m_COL_KNOBFACE[3]={0x00b0b1b2,0x0089a38d,0x009a91a0};
COLORREF		COL_SCOPE_B2,COL_SCOPE_L2,m_COL_SCOPE_B[3]={0x009a7f4f,0x003e553e,0x008d8348},m_COL_SCOPE_B2[3]={0x00675535,0x001d281d,0x005a532e};
COLORREF		myTimeSpectPal[256];
char			laDIR[256];
RX_SIGNAL_STATE myRxSignalState={0};
char			loDIR[256];
InDeviceList	myInDeviceList;
int				noExtIQ=1,internPanorama=0,NetBookFormat=0,FrameBorder=6,lang=GetSystemDefaultLangID()&15;
EXT_IQRX		myExtRxPara={0};

#define MAXFRQSTEPS 12
IF_FILTER_PARA myIFPara=
	{
	//IF_FILTER_PARA
	 DEF_IF_SAMPLE_FRQ,		//int       m_sample_freq;
	 DEF_IF_SAMPLE_NUM,		//int		m_sample_num;
	  4000,		//int		m_lo;
	 20000,		//int		m_hi;
		0,		//int		m_mi;
		0,		//int		m_maxwidth;
	16000,		//int		width;
	 4000,		//int		pos;
	 2000,		//int		potifilt;
		0,		//int		IFLines;

			{ //IF_ANA_STYLE 
					NULL,	//SpectrumCtrlWin
					NULL,	//messageWin
					NULL,	//sendDBLCLICK
					NULL,	//sendSCALEOPT
					NULL,	//sendMOUSEWHEEL

					0,		//m_mark
					0,		//m_fftmarklo
					0,		//m_fftmarkhi
					0,		//m_fftrangelo
					0,		//m_fftrangehi
					0,		//m_scalemarklo
					0,		//m_scalemarkhi
				12000,		//m_centermark
				12000,		//m_IFCenter
				12000,		//m_ShiftCenter
					0,		//m_Fcenter
					0,		//m_FOffset
					0,		//m_FWidth
					0,		//m_IFOffset
					0,		//m_Fcenter1
					0,		//m_Fcenter2

					0,		//m_radiofrq
					0,		//m_radiomode

		 IF_STYLE_DEC,		//m_style
		 IF_ALL_MARKERS,	//m_FaceType
					0,		//m_lo
				24000,		//m_hi

	 RGB(220,255,128),		//m_TextColor = COL_YELLOW,
					0,		//m_StartPos;
					0,		//m_BandWidth;
					0,		//topStartPos;
					0,		//topBandWidth;
					0,		//topCenter
					0,		//topCentermark

					0,		//m_ampl
					0,		//m_level
					0,		//m_amplCut		
					0,		//topAmpl		
					0,		//topLevel		
	 IF_STYLE_TOP_TIV,		//topStyle
					45,		//topYPos;	
					0,		//m_contrast;		//the contrast poti value
					0,		//m_bright;			//the brightnes poti value
					128,	//m_intensity;		//the mixline intensity poti value

					 0,		//m_DecScale;		//the spreading of the decibel scale (dB-Scale)
					50,		//m_LargeScale;		//default large of m_DecScale
					20,		//m_SmallScale;		//default small of m_DecScale
				   100,		//m_DecLevel;		//the lower level of the decibel scale (on measurement Mode)
					80,		//m_LargeLevel;		//default large of m_DecLevel
					85,		//m_SmallLevel;		//default small of m_DecLevel
					0,		//m_ColorFlag;		//flag for Time Spectrum Colors ....
					0,		//m_TextMark;
					0,		//m_frq;			//if frequency scale else =0
					0,		//m_decoder;		//type of current decoder

					20,		//m_repeatation;	//the repetation of drawing per secude
					50,		//m_smoothing;	//the smooth/soft drawing delay  level

					0,		//m_onoff:1;
					0,		//topOFF:1;
					1,		//m_TSsmooth:1;
					0,		//m_filterout:1;
					0,		//m_setfilter:1;
					0,		//m_createfilter:1;
					0,		//m_curveonoff:1;
					0,      //m_delayonoff:1;
				   	0,		//m_finetune:4;			
					0,		//m_SpectrumMode:4;	
					0,		//m_channel:4;		//if channel selction then ist this the number 0 mono  bit-0 = right  bit-1 = left  3=stereo
					0,		//m_draw_frq_label:1;
					0,		//m_stored:1		//indicator for swap IF and AF Page	
					0,		//flag_reserve:10
					{0}     //IFfilter_name[16];
			}
	};

IF_FILTER_PARA myIQPara=
	{
	///IF_FILTER_PARA IQPara=

		//IF_FILTER_PARA
		 48000,		//int       m_sample_freq;
		  2048,		//int		m_sample_num;
		  4000,		//int		m_lo;
		 20000,		//int		m_hi;
			0,		//int		m_mi;
			0,		//int		m_maxwidth;
		16000,		//int		width;
		 4000,		//int		pos;
		 2000,		//int		potifilt;
			0,		//int		IFLines;		
				{ //IF_ANA_STYLE IF
				NULL,	//SpectrumCtrlWin
				NULL,	//messageWin
				NULL,	//sendDBLCLICK
				NULL,	//sendSCALEOPT
				NULL,	//sendMOUSEWHEEL

				0,		//m_mark
				0,		//m_fftmarklo
				0,		//m_fftmarkhi
				0,		//m_fftrangelo
				0,		//m_fftrangehi
				0,		//m_scalemarklo
				0,		//m_scalemarkhi
			12000,		//m_centermark
			12000,		//m_IFCenter
			12000,		//m_ShiftCenter
				0,		//m_Fcenter
				0,		//m_FOffset
				0,		//m_FWidth
				0,		//m_IFOffset
				0,		//m_Fcenter1
				0,		//m_Fcenter2

				0,		//m_radiofrq
				0,		//m_radiomode

	 IF_STYLE_DEC,		//m_style
	 IF_ALL_MARKERS,	//m_FaceType
				0,		//m_lo
			24000,		//m_hi
 RGB(220,255,128),		//m_TextColor = COL_YELLOW,
		   500000,		//m_StartPos;
		  2000000,		//m_BandWidth;
				0,		//topStartPos;
		  2000000,		//topBandWidth;
				0,		//topCenter
				0,		//topCentermark

				0,		//m_ampl
				0,		//m_level
				0,		//m_amplCut		
				0,		//topAmpl		
				0,		//topLevel		
 IF_STYLE_TOP_TIV,		//topStyle
				45,		//topYPos;	
				0,		//m_contrast;		//the contrast poti value
				0,		//m_bright;			//the brightnes poti value
				128,	//m_intensity;		//the mixline intensity poti value

				 0,		//m_DecScale;		//the spreading of the decibel scale (dB-Scale)
				50,		//m_LargeScale;		//default large of m_DecScale
				20,		//m_SmallScale;		//default small of m_DecScale
			   100,		//m_DecLevel;		//the lower level of the decibel scale (on measurement Mode)
				80,		//m_LargeLevel;		//default large of m_DecLevel
				85,		//m_SmallLevel;		//default small of m_DecLevel
				0,		//m_ColorFlag;		//flag for Time Spectrum Colors ....
				0,		//m_TextMark;
				0,		//m_frq;			//if frequency scale else =0
				0,		//m_decoder;		//type of current decoder

				20,		//m_repeatation;	//the repetation of drawing per secude
				50,		//m_smoothing;	//the smooth/soft drawing delay  level

				0,		//m_onoff:1;
				0,		//topOFF:1;
				1,		//m_TSsmooth:1;
				0,		//m_filterout:1;
				0,		//m_setfilter:1;
				0,		//m_createfilter:1;
				0,		//m_curveonoff:1;
				0,      //m_delayonoff:1;
				0,		//m_finetune:4;			
				0,		//m_SpectrumMode:4;	
				0,		//m_channel:4;		//if channel selction then ist this the number 0 mono  bit-0 = right  bit-1 = left  3=stereo
				0,		//m_draw_frq_label:1;
				0,		//flag_reserve
				{0}     //IFfilter_name[16];
				}

	};


#define MAX_IQ_RADIOS 9
#define LAST_IQ_RADIO 8
char		*radios[MAX_IQ_RADIOS]={
					"intern RadioJet IQ-Receiver",
					"FiFi-SDR",			
                    "Pappradio",  
                    "ELAD FDM-S1",  
					"SDR-IQ/14",			
                    "PM-SDR",  
                    "Perseus",  
					"Excalibur",
					"Excalibur Pro"
					};


/*
typedef struct
	{
	WORD			H;			// Hue ( * 8192 / 60)
	BYTE			S;			// Saturation (0...255)
	BYTE			V;			// Brightness (0...255)
	} HSV;


WINAPI HSV RGB2HSV 

double r, g, b;

V = max(R,G,B) 
S = (V-min(R,G,B))/V if V<>0, 0 otherwise 
H = 
(G - B)/6/S, if V=R; 
1/2+(B - R)/6/S, if V=G; 
2/3+(R - G)/6/S, if V=B. 
*/


double WINAPI HuetoRGB(double m1, double m2, double h )
{
	if( h < 0 ) h += 1.0;
	if( h > 1 ) h -= 1.0;
	if( 6.0*h < 1 )
		return (m1+(m2-m1)*h*6.0);
	if( 2.0*h < 1 )
		return m2;
	if( 3.0*h < 2.0 )
		return (m1+(m2-m1)*((2.0/3.0)-h)*6.0);
	return m1;
}

COLORREF WINAPI HLStoRGB_ONE( double H, double L, double S )
{
	double r, g, b;
	double m1, m2;
	
	if(S==0) {
		r=g=b=L;
	} else {
		if(L <=0.5)
			m2 = L*(1.0+S);
		else
			m2 = L+S-L*S;
		m1 = 2.0*L-m2;
		r = HuetoRGB(m1, m2, H+1.0/3.0);
		g = HuetoRGB(m1, m2, H);
		b = HuetoRGB(m1, m2, H-1.0/3.0);
	}
	return RGB((BYTE)(r*255), (BYTE)(g*255), (BYTE)(b*255));
}


void WINAPI RGBtoHSL( COLORREF rgb, double *H, double *S, double *L)
{   
	double delta;
	double r = (double)GetRValue(rgb)/255;
	double g = (double)GetGValue(rgb)/255;
	double b = (double)GetBValue(rgb)/255;   
	double cmax = max(r, max(g, b));
	double cmin = min(r, min(g, b));   
	*L=(cmax+cmin)/2.0;   
	
	if(cmax==cmin) 
	{
		*S = 0;      
		*H = 0; // it's really undefined   
	} 
	else 
	{
		if(*L < 0.5) 
			*S = (cmax-cmin)/(cmax+cmin);      
		else
			*S = (cmax-cmin)/(2.0-cmax-cmin);      
		
		delta = cmax - cmin;
		if(r==cmax) 
			*H = (g-b)/delta;      
		else if(g==cmax)
			*H = 2.0 +(b-r)/delta;
		else          
			*H=4.0+(r-g)/delta;
		*H /= 6.0; 
		if(*H < 0.0)
			*H += 1;  
	}
}

COLORREF WINAPI AddBasisColor(COLORREF col, double luminace)
{
	double m_dblHue,m_dblSat,m_dblLum;
	RGBtoHSL (col, &m_dblHue, &m_dblSat, &m_dblLum);
//	luminace*=.4;

	m_dblLum+=luminace;
	if(m_dblLum>.99) m_dblLum=.99;
	else if(m_dblLum<0.01) m_dblLum=0.01;

	return HLStoRGB_ONE(m_dblHue,m_dblLum,m_dblSat);
}

COLORREF WINAPI GetBasisSaturation(COLORREF col, double saturation)
{
	double m_dblHue,m_dblSat,m_dblLum;
	RGBtoHSL (col, &m_dblHue, &m_dblSat, &m_dblLum);
	return HLStoRGB_ONE(m_dblHue,m_dblLum,saturation);
}

COLORREF WINAPI GetBasisLuminace(COLORREF col, double luminace)
{
	double m_dblHue,m_dblSat,m_dblLum;
	RGBtoHSL (col, &m_dblHue, &m_dblSat, &m_dblLum);
	return HLStoRGB_ONE(m_dblHue,luminace,m_dblSat);
}

int initGR=0;
int selectedDesign=0;
void WINAPI	InitGraficUtilitys(int set)
{
	COL_BACK		=GetSysColor(COLOR_BTNFACE);
	COL_KNOBFACE	=RGB(128,198,218);
	myLIGHT			=GetSysColor(COLOR_3DLIGHT);
	myDARK			=GetSysColor(COLOR_3DSHADOW);
	myVDARK			=GetSysColor(COLOR_3DDKSHADOW);
	COL_BTXT		=GetSysColor(COLOR_BTNTEXT);
	myVLIGHT		=AddBasisColor(myLIGHT,.1);
	COL_SCOPEMARK	=RGB(240,40,0);
	COL_SCOPE_B		=AddBasisColor(COL_BACK,-.12);//RGB(64,64,32); //dark green background
	COL_SCOPE_L		=AddBasisColor(COL_SCOPE_B,.05);
	COL_SCOPE_P		=AddBasisColor(COL_SCOPE_B,.1);
	COL_SCOPE_LINE	=COL_BTXT;

	selectedDesign=set;

	COL_KNOBFACE	=m_COL_KNOBFACE[set];
	COL_SCOPE_B		=m_COL_SCOPE_B[set];
	COL_SCOPE_B2	=m_COL_SCOPE_B2[set];

	//for the blue desing button (Design-1)
	desCol[0]=GetBasisSaturation(m_COL_SCOPE_B[0],.99);
	desCol[0]=GetBasisLuminace(desCol[0],.25);

	//for the green desing button (Design-2)
	desCol[1]=GetBasisSaturation(m_COL_SCOPE_B[1],.99);
	desCol[1]=GetBasisLuminace(desCol[1],.25);

	//for the brown desing button (Design-3)
	desCol[2]=GetBasisSaturation(m_COL_SCOPE_B[2],.99);
	desCol[2]=GetBasisLuminace(desCol[2],.25);

	COL_SCOPE_L		=AddBasisColor(COL_SCOPE_B,.05);
	COL_SCOPE_L2	=AddBasisColor(COL_SCOPE_B2,.05);

	COL_SCOPE_P		=AddBasisColor(COL_SCOPE_B,.1);
	COL_SCOPE_LINE	=AddBasisColor(COL_SCOPE_B,.75);
	myDesingTextColor=GetBasisSaturation(COL_KNOBFACE,.9);
	myDesingTextColor=GetBasisLuminace(myDesingTextColor,.2);

	mCOL.scope_back=&ana_back;
	mCOL.scope_range=&ana_range;

	InitRJ10Colors(&mCOL);

	myIFPara.ViewStyle.m_TextColor=COL_SCOPE_LINE;

	scopeback.DeleteObject();
	scopeback.CreateSolidBrush(COL_SCOPE_B);
	scopelight.DeleteObject();
	scopelight.CreateSolidBrush(COL_SCOPE_L);
	scopePenLine.DeleteObject();
	scopePenLine.CreatePen(PS_SOLID, 1,COL_SCOPE_LINE);
	scopePenL.DeleteObject();
	scopePenL.CreatePen(PS_SOLID, 1,COL_SCOPE_L);
	scopePenP.DeleteObject();
	scopePenP.CreatePen(PS_SOLID, 1,COL_SCOPE_P);
	scopePenCenter.DeleteObject();
	scopePenCenter.CreatePen(PS_SOLID, 1,AddBasisColor(COL_SCOPE_LINE,-.20)); //MARKHI
	scopePenSplitLine.DeleteObject();
	scopePenSplitLine.CreatePen(PS_SOLID, 1,AddBasisColor(COL_SCOPE_L,.20));
	scopePenFilter.DeleteObject();
	scopePenFilter.CreatePen(PS_SOLID, 1,AddBasisColor(COL_SCOPE_P,.15)); //MARKLO
	scopePenMark.DeleteObject();
	scopePenMark.CreatePen(PS_SOLID, 1,COL_SCOPEMARK);

	scopefill.DeleteObject();
	scopefill.CreateSolidBrush(AddBasisColor(COL_SCOPE_L,-.01));
	scopeLightDotPenCenter.DeleteObject();
	scopeLightDotPenCenter.CreatePen(PS_SOLID, 1,AddBasisColor(COL_SCOPE_P,.25)); //vight Centermark


	COLORREF colSpectScale	=AddBasisColor(COL_SCOPE_B,-.09);
	//create my time spectrum color palette
	int nShift =8,nSteps = 256;
	BYTE	Red,Green,Blue;
	for (int i = 0; i < nSteps; i++)
		{
		Red = (BYTE) ((GetRValue(colSpectScale) * (nSteps - i) + GetRValue(COL_SCOPE_LINE) * i) >> nShift);
		Green = (BYTE) ((GetGValue(colSpectScale) * (nSteps - i) + GetGValue(COL_SCOPE_LINE) * i) >> nShift);
		Blue = (BYTE) ((GetBValue(colSpectScale) * (nSteps - i) + GetBValue(COL_SCOPE_LINE) * i) >> nShift); 
		myTimeSpectPal[i]=RGB(Red,Green,Blue);
		}

	if(initGR) return;


	initGR=1;

	LOGFONT	myfont=		{	//SmallFont
					   -12,	//lfHeight;
						0,	//lfWidth;
						0,	//lfEscapement;
						0,	//lfOrientation;
				 FW_NORMAL,	//lfWeight;
						0,	//lfItalic;
						0,	//lfUnderline;
						0,	//lfStrikeOut;
						0,	//lfCharSet;
						0,	//lfOutPrecision;
						0,	//lfClipPrecision;
						0,	//lfQuality;
 DEFAULT_PITCH | FF_SWISS,	//lfPitchAndFamily;
		{"MS Sans Serif\0    "}};	//lfFaceN

	fontRegular.CreateFontIndirect(&myfont);
	myfont.lfWeight=FW_BOLD;
	fontBold.CreateFontIndirect(&myfont);

	strcpy(myfont.lfFaceName,"Arial");
	myfont.lfWidth=12;
	myfont.lfHeight=-16;
	BigFont.CreateFontIndirect(&myfont);

	myfont.lfWidth=0;
	myfont.lfHeight=-42;
	myfont.lfWeight=FW_BOLD;
	BigDateFont.CreateFontIndirect(&myfont);

	myfont.lfHeight=-14;
	strcpy(myfont.lfFaceName,"Courier new");
	fixFont.CreateFontIndirect(&myfont);

	myfont.lfHeight=-9;
	strcpy(myfont.lfFaceName,"Small Fonts");
	minibigfont.CreateFontIndirect(&myfont);
	myfont.lfWeight=FW_NORMAL;
	minifont.CreateFontIndirect(&myfont);
}

void WINAPI	FillScopeBack(HDC hdc, CRect &rect,COLORREF col1, COLORREF col2) 
{
	int nShift = 8;
	int nSteps = 1 << nShift;

	CRect re=rect;
	
	for (int i = 0; i < nSteps; i++)
		{
		 re.bottom = rect.bottom - ((i * rect.Height()) >> nShift);
         re.top = rect.bottom - (((i + 1) * rect.Height()) >> nShift);
         if (re.Height() > 0)  
			{
			// do a little alpha blending
			BYTE bR = (BYTE) ((GetRValue(col1) * (nSteps - i) + GetRValue(col2) * i) >> nShift);
			BYTE bG = (BYTE) ((GetGValue(col1) * (nSteps - i) + GetGValue(col2) * i) >> nShift);
			BYTE bB = (BYTE) ((GetBValue(col1) * (nSteps - i) + GetBValue(col2) * i) >> nShift);
			CBrush br (RGB(bR, bG, bB));
			 ::FillRect(hdc,re,br);
			}
		}
}

void  WINAPI FillGradient (CDC *m_dc, CRect rect,COLORREF colorStart, COLORREF colorFinish, BOOL bHorz)
{
	int		nShift = 5,nShift2 = 6;
    int		nSteps = 1 << nShift;
	int		nSteps2,zx;
	int		x,z,i,val=0;
	BYTE	bR,bG,bB,pR,pG,pB;
	COLORREF pickCol=0;

	nSteps2 = 44;	//like glass button
	zx=nSteps2-18;
	rect.top++;
    CRect r2;

    for (i = 0; i< nSteps2; i++)
		{
        bR = (BYTE) ((GetRValue(colorStart) * (nSteps2 - i) +  GetRValue(colorFinish) * i) /nSteps2);
        bG = (BYTE) ((GetGValue(colorStart) * (nSteps2 - i) +  GetGValue(colorFinish) * i) /nSteps2);
        bB = (BYTE) ((GetBValue(colorStart) * (nSteps2 - i) +  GetBValue(colorFinish) * i) /nSteps2);

		CBrush br (RGB(bR, bG, bB));
		r2 = rect;
        r2.bottom = rect.bottom - ((i * rect.Height()) >> nShift);
        r2.top = rect.bottom - (((i + 1) * rect.Height()) >> nShift);
		if(r2.top<(rect.top+1)) break;
        if (r2.Height() > 0) m_dc->FillRect(r2, &br);
		}

	for (z=5,i = zx-2; i< nSteps2; i++)
		{
        bR = (BYTE) ((GetRValue(colorStart) * (nSteps2 - i) +  GetRValue(colorFinish) * i) /nSteps2);
        bG = (BYTE) ((GetGValue(colorStart) * (nSteps2 - i) +  GetGValue(colorFinish) * i) /nSteps2);
        bB = (BYTE) ((GetBValue(colorStart) * (nSteps2 - i) +  GetBValue(colorFinish) * i) /nSteps2);

		CBrush br (RGB(bR, bG, bB));
		x=i-zx+18;
        r2 = rect;
        r2.bottom = rect.bottom - ((x * rect.Height()) >> nShift);
		if(r2.top<rect.top) break;
        r2.top = rect.bottom - (((x + 1) * rect.Height()) >> nShift);
        if (r2.Height() > 0)  
			{
			if(z>-1 && r2.bottom!=val)
				{
				r2.left+=z; r2.right-=z;
				pickCol=m_dc->GetPixel(r2.left,r2.top);
				pR = (BYTE) ((bR + GetRValue(pickCol)) /2);
				pG = (BYTE) ((bG + GetGValue(pickCol)) /2);
				pB = (BYTE) ((bB + GetBValue(pickCol)) /2);
				m_dc->SetPixel(r2.left,r2.top,RGB(pR,pG,pB)); 
				r2.left++;

				pickCol=m_dc->GetPixel(r2.right-1,r2.top);
				pR = (BYTE) ((bR + GetRValue(pickCol)) /2);
				pG = (BYTE) ((bG + GetGValue(pickCol)) /2);
				pB = (BYTE) ((bB + GetBValue(pickCol)) /2);
				m_dc->SetPixel(r2.right-1,r2.top,RGB(pR,pG,pB));
				r2.right--;
				z--; val=r2.bottom;			
				}

			m_dc->FillRect(r2, &br);
			}
		}
}

void WINAPI DrawStyleRect(CDC* pDC, CRect& rect, COLORREF col) 
{
	pDC->Draw3dRect (rect,col, col);
	pDC->SetPixel(rect.left+1,rect.top+1,col);
	pDC->SetPixel(rect.right-2,rect.top+1,col);
	pDC->SetPixel(rect.left+1,rect.bottom-2,col);
	pDC->SetPixel(rect.right-2,rect.bottom-2,col);

	pDC->SetPixel(rect.left,rect.top,COL_BACK);
	pDC->SetPixel(rect.right-1,rect.top,COL_BACK);
	pDC->SetPixel(rect.left,rect.bottom-1,COL_BACK);
	pDC->SetPixel(rect.right-1,rect.bottom-1,COL_BACK);
}

void WINAPI SetVariButtonLine(CRect& re, MyButton* b, int count,int offset)
{
	int i,rest,set,cx,off,x=re.left,cy=re.Height();

	for(cx=0,i=0; i<count; i++) cx+=b[i].GetXsizeOfContent();
	cx+=offset;
	off=(re.Width()-cx)/count;
	rest=re.Width()-cx-(count*off);
			
	for(i=0; i<count; i++)
		{
		set=off;
		if(rest<0) {set--; rest++;}
		else if(rest>0) {set++; rest--;}
		x=b[i].SetXsizeOfContent(x,re.top,cy,set);
		}
}

char strbuf[256];
char *WINAPI GetMyProfileString(char *AppName, char *KeyName, char *value)
{
	char profilename[256];
	sprintf(profilename,"%s\\RJ10M.ini",myDIR);
	strcpy(strbuf,value);
	GetPrivateProfileString(AppName,KeyName,value,strbuf,255,profilename);
	return strbuf;
}

UINT WINAPI GetMyProfileInt(char *AppName, char *KeyName, int value)
{
	char profilename[256];
	sprintf(profilename,"%s\\RJ10M.ini",myDIR);
	return GetPrivateProfileInt(AppName,KeyName,value,profilename);
}

BOOL WINAPI WriteMyProfileInt(char *AppName, char *KeyName, int value)
{
	char profilename[256], val[256];
	sprintf(profilename,"%s\\RJ10M.ini",myDIR);
	sprintf(val,"%d",value);
	return WritePrivateProfileString(AppName,KeyName,val,profilename);
}


BOOL WINAPI getRegString(HKEY key, char *KeyName, char *ValName, char *Default, char* DatBuf)
{
	HKEY	hKey;
	long	retCode;
	DWORD	dat_sodb=255,val_type=REG_SZ;

	DatBuf[0]=0;

	retCode=RegOpenKeyEx(key,KeyName,0,KEY_READ,&hKey);
	if(!retCode)
		{
		retCode=RegQueryValueEx(
							hKey,				// handle to key to query
							ValName,			// address of name of value to query
							NULL,				// reserved
							&val_type,			// address of buffer for value type
							(BYTE*)DatBuf,		// address of data buffer
							&dat_sodb			// address of data buffer size
							);
  		RegCloseKey (hKey); 
		}
	if(retCode && Default) strcpy(DatBuf,Default);
	return(retCode);
}

#include  <io.h>
#include <direct.h>
BOOL WINAPI GetMyAccessDir()
{
	_getcwd(myDIR,255);


#ifndef _DEBUG			//is only for Bonito, I test this with the Debug_DLL in my RadioJet Directory 
	char file[256];
	sprintf(file,"%s\\RJ10.dll",myDIR);
	if(_access(file,0)!=-1)
		{
		return NULL;
		}
#endif

   //otherwise, it is searched
	BOOL ret=getRegString(HKEY_CURRENT_USER,"Software\\Bonito\\RadioJet 1.0","AccessDir",myDIR,myDIR);
	if(ret)	ret=getRegString(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Bonito RadioJet 1.0","AccessDir",myDIR,myDIR);
 
	return ret;
}

#include <math.h>
#include <float.h>
//convert magnitude to logarithmic dB value
float WINAPI todB(float value)
{
	//prevent  mathematic error
	float data=0;
	double dbl=value;
	if(value>FLT_MIN && value<FLT_MAX) //xp-limit of magbitude ~144 db
		{
		try
			{
			data=(float)(log10(dbl*dbl));
			}
		catch(...)
			{
			data=0;
			}
		}
	return data;
}


int	lprcPointer=0;
CRect Monitor[3];
BOOL CALLBACK MyInfoEnumProc(
  HMONITOR hMonitor,  // handle to display monitor
  HDC hdcMonitor,     // handle to monitor-appropriate device context
  LPRECT lprcMonitor, // pointer to monitor intersection rectangle
  LPARAM dwData       // data passed from EnumDisplayMonitors
)

{
	lprcPointer++;
	if(lprcPointer<3)
		{
		Monitor[lprcPointer]=lprcMonitor;
		}

	return TRUE;
}

void WINAPI GetMonitorRect(CRect &rect)
{
	HMONITOR mon=MonitorFromWindow(myMainFrm->m_hWnd,MONITOR_DEFAULTTONEAREST);
	MONITORINFO m={0}; 
	m.cbSize=sizeof(MONITORINFO);
	GetMonitorInfo(mon,&m);
	rect=m.rcWork;
}

void WINAPI SetCheckPlacement(HWND hwnd, CRect &rect, UINT flags)
{
	POINT	pt;
	int		i,z;

	lprcPointer=-1;
	EnumDisplayMonitors(NULL, NULL, MyInfoEnumProc, 0);

	pt=rect.CenterPoint();

	for(z=i=0; i<=lprcPointer; i++)
		{
		if(Monitor[i].PtInRect(pt)) 
			{
			z=1; break;
			}
		}

	if(!z) GetWindowRect(hwnd,rect);
	SetWindowPos(hwnd,NULL,rect.left,rect.top,rect.Width(),rect.Height(),flags|SWP_NOZORDER|SWP_NOOWNERZORDER|SWP_NOACTIVATE);
}
