#if !defined(AFX_MYBUTTON_H__909580A9_BAB3_4F9E_B6E6_999E9F353620__INCLUDED_)
#define AFX_MYBUTTON_H__909580A9_BAB3_4F9E_B6E6_999E9F353620__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyButton.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyButton window
#define FLAT_BOTTON		1
#define TAB_BOTTON		2
class MyButton : public CButton
{
	DECLARE_DYNCREATE(MyButton)
// Construction
public:
	MyButton();

// Attributes
public:

	int			dir,m_state,m_bold,CheckPos;
	UINT		m_menu,m_nMenuResult;
	COLORREF	TextColor;
	BOOL		m_bMenuInAction;
	BOOL		m_bPushed;
	BOOL		m_bHighlighted;
	BOOL		m_bCaptured;
	BOOL		m_bRighImage;
	int			m_bButtonStyle;	//1=flat button 2= tab button
	int			m_noBorder;	//intim seting
	CImageList	m_img;
	CSize		imgSize;
	CToolTipCtrl m_tooltip;
	HMENU		m_hMenu;

// Operations
public:

	void		OnDraw(CDC* pDC,CRect rect);
	void		SetImage(UINT ID=0,int rightImage=0); //NULL = CLEAR Image
	void		SetImage (HBITMAP hbm);
	void		SetCheck(int state, BOOL bRedraw=TRUE);
	void		SetBold(int bold, BOOL bRedraw=TRUE);
	void		SetStyle(int style, BOOL bRedraw=TRUE);
	void		SetMenu(UINT menu);
	void		SetMenu(HMENU menu);
	void		CheckMenuItem(int pos, char *txt=NULL);
	void		SetColor(COLORREF col=-1, int bold=0, BOOL bRedraw=TRUE);
	void		DrawBitmap(HDC hDC, int iLeft, int iTop, HBITMAP hBitmap);
	void		FillBackground (CDC* pDC, const CRect& re);
	void		OnShowMenu(); 
	int			GetXsizeOfContent();
	int			SetXsizeOfContent(int x,int y,int cy,int off);
	void		SetTooltip (char *ttt);
	void		SetTooltip (UINT tttID);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyButton)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	protected:
	virtual void PreSubclassWindow();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~MyButton();

	// Generated message map functions
protected:
	//{{AFX_MSG(MyButton)
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEnable(BOOL bEnable);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYBUTTON_H__909580A9_BAB3_4F9E_B6E6_999E9F353620__INCLUDED_)
