#if !defined(MY_CDC_BITMAP)
#define MY_CDC_BITMAP

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyIFView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyIFView window

typedef CArray<int,int&> IntArray;

class MyDCBitmap
{
public:
	MyDCBitmap();
	virtual ~MyDCBitmap();

	HDC			m_hdcScr,m_hdcDst;
	int			m_bpl;	//bit per line
	int			m_width,m_height; 
	BYTE		*m_adr,*m_pnt;
	HWND		m_hWnd;
	HBITMAP		o_hbm,m_hbm;


// BITMAPINFO
	typedef struct CDIB_BITMAP
		{
		BITMAPINFOHEADER bmiHead;
		RGBQUAD			 rgb[256];
		} CDIB_BITMAP;
	CDIB_BITMAP m_dib;


	int		Copy(MyDCBitmap& cib);
	BOOL	operator=(MyDCBitmap& cib) {return Copy(cib);}
	
	MyDCBitmap(MyDCBitmap& cib) {Copy(cib);}

	int		CreateBitmap(HWND hWnd, int width, int height,COLORREF fillCollor=RGB(255,255,255));
	void	DeleteBitmap(void);

	HDC		SelectCompatibleDC();
	void	DeleteCompatibleDC();
	BOOL	BitBlt(HDC hdc, int x, int y, int nWidth, int nHeight, int xSrc, int ySrc, DWORD dwRop);
	BYTE*	GetMapAdress(int x, int y);
	void	AddAreaBrightness(int xstart, int ystart, int xend, int yend, float factor);



};
#endif MY_CDC_BITMAP