//MyKnob.h: interface for the MyKnob class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(MYPEEKMETER)
#define MYPEEKMETER

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class MyPeekMeter : public CButton
{
	DECLARE_DYNCREATE(MyPeekMeter)
public:		
		MyPeekMeter();

	BOOL			Init(DWORD flags, LPCTSTR txt);

	DWORD			m_flags;
	CRect			m_size;
	
	CString			m_text;
	float			m_delayA,m_delayB,m_PeekMax,m_sval;
	int				oldVal;

	void			Move(int xp, int yp);
	void			Size(int xs, int ys);
	void			SetRange(int PeekMax);
	void			SetDelay(int delay);
	void			SetPeakMeter(int set);
	void			Set(int v);
	void			Draw(CDC *pDC);



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyPeekMeter)
protected:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_VIRTUAL
// Implementation
public:
	virtual ~MyPeekMeter();
	//{{AFX_MSG(MyPeekMeter)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif // !defined(MYPEEKMETER)
