#if !defined(WG31DDC_DLL)
#define WG31DDC_DLL

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma pack(push)
#pragma pack(1)

#include "G31DDCapi.h"
///////////////////////////////////////////////////////////////////////////////////////////////

class G31DDCDll 
{
private:
	HINSTANCE			h_lib;
	G3XDDC_DDC_INFO		DDCInfo;
	UINT32				DDCTypeIndex;
	G31DDC_CALLBACKS	Callbacks;

public:

			G31DDCDll();
virtual		~G31DDCDll();


public:

	void				CloseExtRx();
	BOOL				OpenExtRx();

	int					IsRunning,lastMode,hDevice;

	BOOL				LoadDLL();
	BOOL				FreeDLL();

	BOOL				SetSampleMode(int mode);
	void				ClearVariables();

	int					SetFrequency(int freq);
	void				_SetATT(int att);
	void				_SetDither(BOOL enable);
	void				_SetNB(BOOL enable);
	void				Set_dBmOfsset();
	void				SetPower(BOOL onoff);
	BOOL				CodecStart();
	BOOL				CodecStop();
					
	unsigned int		GetInfo(char *buf);
	float				*DataBuf,dBcorr;


};

#pragma pack(pop)
#endif // !defined(WRG_DLL)
