#if !defined(SI570_DRIVER)
#define SI570_DRIVER

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma pack(push)
#pragma pack(1)

#include <windows.h>

#include "RJ1102SDLL.h"


class CSi570Driver : public RJ1102SDLL
{
public:
						CSi570Driver();
			virtual		~CSi570Driver();
							

	BOOL		Open(UINT PID=RJ10_PID);
	void		si570reset(void);
	void		Reset();
	void		CheckStartUpFrq();
	void		Refresh_Frequency();
	void		SetFreq(int frq);

	int			Set_Frequency(int freq);
	void		Set_ShortFreq(UINT64 frq);
	void		Set_LongFreq(UINT64 frq);

	void		_SetATT(int att);
	void		_SetPRE(int pre);

	int			DDSFrq;
};

#pragma pack(pop)
#endif // !defined(SI570_DRIVER)
