// IFJet1102DLLThread.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "IFJet1102DLLThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IFJet1102DLLThread


IMPLEMENT_DYNCREATE(IFJet1102DLLThread, CWinThread)

IFJet1102DLLThread::IFJet1102DLLThread(){}
IFJet1102DLLThread::~IFJet1102DLLThread(){}
BOOL IFJet1102DLLThread::InitInstance()
{
	return TRUE;
}

int IFJet1102DLLThread::ExitInstance()
{
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(IFJet1102DLLThread, CWinThread)
	//{{AFX_MSG_MAP(IFJet1102DLLThread)
	ON_THREAD_MESSAGE(WM_PROCESS_IFIN,	OnProcessIFInput)
	ON_THREAD_MESSAGE(WM_PROCESS_IQIN,	OnProcessIQInput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IFJet1102DLLThread message handlers

int IFJet1102DLLThread::Run() 
{
	return CWinThread::Run();
}

//Background Thread Process for critical routines

void IFJet1102DLLThread::OnProcessIFInput(WPARAM wParam, LPARAM lParam)
{
	//wParam= short *AudioData 
	//lParam= DataCounter or DataID 
	if(!StopFlag)
		{
		IFinpuThreadWorkFlag=1;
		ProcessIFInput(WM_PROCESS_IFIN, wParam,lParam);	//get the complicated job done in the DLL.darkness 
		IFinpuThreadWorkFlag=0;
		}
}

void IFJet1102DLLThread::OnProcessIQInput(WPARAM wParam, LPARAM lParam)
{
	//wParam= short *AudioData 
	//lParam= DataCounter or DataID 
	if(!StopFlag)
		{
		IQinpuThreadWorkFlag=1;
		ProcessIFInput(WM_PROCESS_IQIN, wParam,lParam);	//get the complicated job done in the DLL.darkness 
		IQinpuThreadWorkFlag=0;
		}
}
