#if !defined(COLOR_PICKER_BUTTON)
#define COLOR_PICKER_BUTTON

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// olorPickerButton.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyColorPickerButton window

class MyColorPickerButton : public CButton
{
	DECLARE_DYNCREATE(MyColorPickerButton)
// Construction
public:
	MyColorPickerButton();

// Attributes
public:

	double			m_dblHue,m_dblSat,m_dblLum;
	double			l_dblHue,l_dblSat,l_dblLum;
	COLORREF		m_colorNew;
	CBitmap			m_bmpPicker;
	CPoint			colorP;
	int				m_Y,l_Y,mouse_activ,init;
	CRect			myRect,l_Rect;

	void			SetRGB(COLORREF ref, int flag=0);
	void			SetRGBLUM(int flag, COLORREF ref, double lumi);
	void			DrawLuminace(CDC* pDC, CRect &rl, CRect &rr);
	void			SetPoint(CPoint point);
	void			UndoRGBLUM();
	COLORREF		SetMyHSL();


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyColorPickerButton)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~MyColorPickerButton();

	// Generated message map functions
protected:
	//{{AFX_MSG(MyColorPickerButton)#
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(COLOR_PICKER_BUTTON)
